var lines = [] //drawn lines are saved here - in the empty array
var penColor
var bgColor
var penWidth
var clearBut
var saveBut
var penShape
var penRandom
var slider
var softBrush
var brush

function setup(){
    createCanvas(500, 500).style('display:flex; border-radius: 13px;')
    noiseDetail(4)
    softBrush = loadImage('soft-brush.png')
    brush = softBrush;
    var options = createDiv().style('display: flex;')

    var optionsTitles = createDiv().parent(options).style('font-family: Arial, Helvetica, sans-serif; margin-left:10px; font-size:15px')
    createP('Pen Color').parent(optionsTitles).style('margin-top:17px')
    createP('Background Color').parent(optionsTitles).style('margin-top:20px')
    createP('Pen Width').parent(optionsTitles).style('margin-top:16px')
    createP('Pen Shape').parent(optionsTitles)

    var optionsValues = createDiv().parent(options).style('margin:10px 40px; width: 80px')
    penColor = createColorPicker('#1e1e1e').parent(optionsValues)
    penRandom = createCheckbox("", false).parent(optionsValues).style('display:inline; margin-left:4px') 
    bgColor = createColorPicker('#D3D3D3').parent(optionsValues).style('margin-top: 10px')
    penWidth = createSlider(1, 50, 2).parent(optionsValues).style('margin-top: 15px; width: 90px; color:black;')

    penShape = createSelect(false).parent(optionsValues).style('margin-top:11px; margin-bottom:5px')
    penShape.option('Line')
    penShape.option('Circle')
    penShape.option('Rectangle') 

    clearBut = createButton('Clear').parent(options).style('width: 55px; height: 35px; margin-top: 55px; margin-left:30px; border-radius: 5px; border-color:gray;')
    saveBut = createButton('Save').parent(options).style('width: 55px; height: 35px; margin-top: 55px; margin-left:30px; border-radius: 5px; border-color:gray;') // Added 'save' Button
}

function draw(){
    background(bgColor.value())

    if(penRandom.checked()){
        var r = hex(floor(map(noise(frameCount / 100 + 1000),0,1,0,255)),2) // noise function creates random values 
        var g = hex(floor(map(noise(frameCount / 100 + 3000),0,1,0,255)),2)
        var b = hex(floor(map(noise(frameCount / 100 + 4000),0,1,0,255)),2)
         //creates rgb values
    penColor.value('#' + r + g + b) 
    }
    
    clearBut.mousePressed(function(){
        lines = []
    })

    saveBut.mousePressed(function(){  // 'save' button function
    saveCanvas('myCanvas', 'jpg');
    })

    if(mouseIsPressed){
        var line = new MyLine(penColor.value(), penWidth.value(), penShape.value())
        lines.push(line)
    }

    for (var line of lines) { //draws the lines that are saved in the array
        line.show()
    }
}



 
